from django.shortcuts import render
from rakka.utils import rerender
from . import models
from main.models import Update

@rerender
def nerdshope():
	accounts=models.BankAccount.objects.all()
	sums={curr:sum([n.balance for n in filter(lambda x:x.currency==curr,accounts)]) for curr in set(map(lambda x:x.currency,accounts))}
	moneyblob='</li>\n<li>'.join([f'{k}: {v}' for k,v in sums.items()])
	moneyblob='Current monetary state: <ul>\n<li>'+moneyblob+'</li>\n</ul>'
	return {'title':"Nerds' Hope",'content':"Store stuff. TODOing. Will include inventory and budget. <a href='https://facebook.com/nerdshope'>FB</a><br/>\nAddress is 21 Kensington St, Glenorchy<br/>\nThe store isn't open when other events happen on Fridays, usually the last Friday of each month. Additionally, on the first and third weeks of each month the store will move around the back (through the gate) around 18:00 to make room for a youth group. If in doubt, ask the youth group for directions.<br/>\nFull list of dates:\n<ol><li>16th Sept - round the back later</li>\n<li>30th Sept - closed</li>\n<li>21st Oct - round the back later</li>\n<li>28th Oct - closed</li>\n<li>4th Nov - round the back later</li>\n<li>18th Nov - round the back later</li>\n<li>25th Nov - closed</li>\n<li>2nd Dec - round the back later</li>\n<li>16th Dec - round the back later</li>\n<li>30th Dec - maybe party</li></ol>\n"+moneyblob,'date':Update.objects.get_or_create(page='nh_main')[0].date}

@rerender
def budget():
	pass
